#ifndef __IKD_OX_TOOLS_OXNUMERICCOUNTER_H__
#define __IKD_OX_TOOLS_OXNUMERICCOUNTER_H__

#include <math.h>


namespace OX {
	/**
	* @brief lJE^[
	*
	* ݒ肳ꂽlɃCNgyуfNg܂Bupdate\bhĂ΂邽т
	* ڕWlƌ݂̒l̍ɑ΂Ĉ̊l߂ɐlϓ܂B
	* wŏlȉɂȂꍇ͌ݒlڕWlƈv܂B
	*/
	class NumericCounter {
	public:
		NumericCounter( float initVal = 0.0f, float minDif = 1.0f, float rate = 0.08f ) : curVal_( initVal ), aimVal_( initVal ), rate_( rate ), minDif_( minDif ) {
		}

		~NumericCounter() {

		}

		/**
		* @brief ڕWlݒ
		* @param[in] aim ڕWl
		*/
		void setAim( float aim ) {
			aimVal_ = aim;
		}

		/**
		* @brief ڕWl擾
		* @return ڕWl
		*/
		float getAim() const {
			return aimVal_;
		}

		/**
		* @brief Xs[hݒ
		*
		* yьXs[h̃p[^ݒ肵܂B
		*/
		void setRate( float rate ) {
			if ( rate < 0.0f )
				rate = 0.0f;
			rate_ = rate;
		}

		/**
		* @brief ݒl𒼐ڎw
		* @param[in] l
		*
		* ݒl𒼐ڎw肵܂B
		*/
		void setDirectValue( float val ) {
			curVal_ = val;
		}

		/**
		* @brief lXV
		*/
		float update() {
			auto dif = aimVal_ - curVal_;
			if ( fabsf( dif ) <= minDif_ ) {
				curVal_ = aimVal_;
			}
			else {
				curVal_ = curVal_ + dif * rate_;
			}
			return curVal_;
		}

	private:
		float minDif_;
		float curVal_;
		float aimVal_;
		float rate_;
	};
}
#endif
